"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _validatorTypes = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/validator-types"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var options = [{
  value: 1,
  label: 'cats'
}, {
  value: 'dog',
  label: 'fog'
}];

var genereateField = function genereateField(component) {
  var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'standard';
  var optionsOptional = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return [{
    name: "".concat(component, " -- ").concat(name, " -- header"),
    component: 'plain-text',
    label: "".concat(component, " -- ").concat(name)
  }, _objectSpread({
    label: "".concat(component, " -- ").concat(name),
    name: "".concat(component, " -- ").concat(name),
    component: component,
    options: component === 'select' || component === 'radio' ? options : undefined
  }, optionsOptional), {
    name: "".concat(component, " -- ").concat(name, " -- divider 2 "),
    component: 'plain-text',
    label: '\n.  \n.'
  }];
};

var componentList = ['text-field', 'checkbox', 'date-picker', 'radio', 'select', 'switch', 'textarea', 'time-picker', 'slider'];
var superSchema = {
  fields: [{
    component: 'tabs',
    name: 'tabs',
    fields: componentList.reduce(function (acc, curr) {
      return [].concat((0, _toConsumableArray2["default"])(acc), [{
        component: 'tab-item',
        name: curr,
        title: curr,
        fields: [].concat((0, _toConsumableArray2["default"])(curr === 'slider' ? [genereateField(curr, 'maxmin', {
          step: 1,
          max: 100,
          min: 0
        })] : []), (0, _toConsumableArray2["default"])(genereateField(curr)), (0, _toConsumableArray2["default"])(genereateField(curr, 'helper text', {
          helperText: 'This is helper text'
        })), (0, _toConsumableArray2["default"])(genereateField(curr, 'placeholder', {
          placeholder: 'This is placeholder'
        })), (0, _toConsumableArray2["default"])(genereateField(curr, 'description', {
          description: 'This is this description'
        })), (0, _toConsumableArray2["default"])(genereateField(curr, 'required error', {
          validate: [{
            type: _validatorTypes["default"].REQUIRED
          }]
        })), (0, _toConsumableArray2["default"])(genereateField(curr, 'isDisabled', {
          isDisabled: true
        })), (0, _toConsumableArray2["default"])(genereateField(curr, 'isReadOnly', {
          isReadOnly: true
        })), (0, _toConsumableArray2["default"])(genereateField(curr, 'is required', {
          isRequired: true
        })), (0, _toConsumableArray2["default"])(curr === 'select' ? [].concat((0, _toConsumableArray2["default"])(genereateField(curr, 'isClearable', {
          isClearable: true
        })), (0, _toConsumableArray2["default"])(genereateField(curr, 'isSearchable', {
          isSearchable: true
        })), (0, _toConsumableArray2["default"])(genereateField(curr, 'isMulti', {
          isMulti: true
        }))) : []), (0, _toConsumableArray2["default"])(curr === 'checkbox' ? [].concat((0, _toConsumableArray2["default"])(genereateField(curr, 'multipleoptions', {
          options: options
        })), (0, _toConsumableArray2["default"])(genereateField(curr, 'multipleoptions helper text', {
          helperText: 'This is helper text',
          options: options
        })), (0, _toConsumableArray2["default"])(genereateField(curr, 'multipleoptions placeholder', {
          placeholder: 'This is placeholder',
          options: options
        })), (0, _toConsumableArray2["default"])(genereateField(curr, 'multipleoptions description', {
          description: 'This is this description',
          options: options
        })), (0, _toConsumableArray2["default"])(genereateField(curr, 'multipleoptions required error', {
          validate: [{
            type: _validatorTypes["default"].REQUIRED
          }],
          options: options
        })), (0, _toConsumableArray2["default"])(genereateField(curr, 'multipleoptions isDisabled', {
          isDisabled: true,
          options: options
        })), (0, _toConsumableArray2["default"])(genereateField(curr, 'multipleoptions isReadOnly', {
          isReadOnly: true,
          options: options
        })), (0, _toConsumableArray2["default"])(genereateField(curr, 'multipleoptions is required', {
          isRequired: true,
          options: options
        }))) : []), (0, _toConsumableArray2["default"])(curr === 'switch' ? [].concat((0, _toConsumableArray2["default"])(genereateField(curr, 'onText', {
          onText: 'Turned on'
        })), (0, _toConsumableArray2["default"])(genereateField(curr, 'offText', {
          offText: 'Turned off'
        })), (0, _toConsumableArray2["default"])(genereateField(curr, 'onText&&offText', {
          onText: 'Turned on',
          offText: 'Turned off'
        }))) : []))
      }]);
    }, [])
  }]
};
var _default = superSchema;
exports["default"] = _default;